package org.molplexdrug.EntityBean;


import static org.jboss.seam.ScopeType.SESSION;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import javax.persistence.OneToMany;

import javax.persistence.Table;

import javax.validation.constraints.NotNull;

import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;

/**
 * @author Jallilah Jeffri
 *
 */
@Entity                                                                               
@Name("assay")                                                                            
@Scope(SESSION)                                                                        
@Table(name="assay") 
public class Assay implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private  int assay_id;
	private String assay_name;
	private String assay_description;
	private String assay_protocal;
	
	private int cost_per_compound_pence;
	private int target_id;
	
	private Compound_Properties compound_properties;
	/**
	 * 
	 */
	public Assay() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/**
	 * @param assay_id
	 * @param assay_name
	 * @param assay_description
	 * @param assay_protocal
	 * @param compound_property_id
	 * @param cost_per_compound_pence
	 * @param target_id
	 */
	

	/**
	 * @return the assay_id
	 */
	@Id @NotNull
	@GeneratedValue( strategy = GenerationType.IDENTITY )
	 @Column( name = "assay_id" )
	public int getAssay_id() {
		return assay_id;
	}

	

	/**
	 * @param assay_id the assay_id to set
	 */
	public void setAssay_id(int assay_id) {
		this.assay_id = assay_id;
	}

	/**
	 * @return the assay_name
	 */
	public String getAssay_name() {
		return assay_name;
	}

	/**
	 * @param assay_name the assay_name to set
	 */
	public void setAssay_name(String assay_name) {
		this.assay_name = assay_name;
	}

	/**
	 * @return the assay_description
	 */
	public String getAssay_description() {
		return assay_description;
	}

	/**
	 * @param assay_description the assay_description to set
	 */
	public void setAssay_description(String assay_description) {
		this.assay_description = assay_description;
	}

	/**
	 * @return the assay_protocal
	 */
	public String getAssay_protocal() {
		return assay_protocal;
	}

	/**
	 * @param assay_protocal the assay_protocal to set
	 */
	public void setAssay_protocal(String assay_protocal) {
		this.assay_protocal = assay_protocal;
	}

	
	

	/**
	 * @return the cost_per_compound_pence
	 */
	public int getCost_per_compound_pence() {
		return cost_per_compound_pence;
	}

	/**
	 * @param cost_per_compound_pence the cost_per_compound_pence to set
	 */
	public void setCost_per_compound_pence(int cost_per_compound_pence) {
		this.cost_per_compound_pence = cost_per_compound_pence;
	}

	/**
	 * @return the target_id
	 */
	public int getTarget_id() {
		return target_id;
	}

	/**
	 * @param target_id the target_id to set
	 */
	public void setTarget_id(int target_id) {
		this.target_id = target_id;
	}
	
	public void setCompound_properties(Compound_Properties compound_properties) {
		this.compound_properties = compound_properties;
	}
	
	 @ManyToOne(fetch=FetchType.LAZY,cascade=CascadeType.MERGE)
		@JoinColumn(name="compound_property_id",
		referencedColumnName="compound_property_id")
	public Compound_Properties getCompound_properties() {
		return compound_properties;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	 @Override
		public String toString() {
			return "Assay [assay_id=" + assay_id + ", assay_name=" + assay_name
					+ ", assay_description=" + assay_description
					+ ", assay_protocal=" + assay_protocal
					+ ", cost_per_compound_pence=" + cost_per_compound_pence
					+ ", target_id=" + target_id + "]";
		}
	
   public void clear(){
	   this.assay_name="";
	   this.assay_description="";
	   this.assay_protocal="";
	   this.cost_per_compound_pence=0;
	   
   }
	
	  
}
